----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:34:55 08/09/2011 
-- Design Name: 
-- Module Name:    PF_test - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity TDC_get is
    Port ( iclk50MHz : in  STD_LOGIC;	--50MHz
           pstart, pend : in  STD_LOGIC;		--inputs from TDC
           pget : out  STD_LOGIC;		--get TDC data
           perr : out  STD_LOGIC;		--error
           pdata : out  STD_LOGIC_VECTOR (8 downto 0));	--output time data
end TDC_get;

architecture Behavioral of TDC_get is
	signal iclk, clk0, clkb, clk250mhz, clk250mhzb : STD_LOGIC;
	signal clk250_0, clk250_0b, clk250_90, clk250_90b, clk250_180, clk250_180b, clk250_270, clk250_270b : STD_LOGIC;

	signal ppend, ppget : STD_LOGIC;
	signal dstart, ddstart, dddstart, dend, d2end, d3end, d4end, d5end, d6end : STD_LOGIC;
	signal dps0, dps90, dps180, dps270, dpe0, dpe90, dpe180, dpe270 : STD_LOGIC;
	signal dpsf0, dpsf90, dpsf180, dpsf270, dpef0, dpef90, dpef180, dpef270 : STD_LOGIC;
	signal dpect0, dpect90, dpect180, dpect270 : STD_LOGIC_VECTOR(6 downto 0);
	signal stamp0, stamp90, stamp180, stamp270 : STD_LOGIC_VECTOR(6 downto 0);
	signal start_time, end_time : STD_LOGIC_VECTOR(8 downto 0);
	signal limit_time : STD_LOGIC_VECTOR(6 downto 0);
--	signal test_ct : STD_LOGIC_VECTOR(8 downto 0);	--for test
	signal dpsff0, dpsff90, dpsff180, dpsff270, dpeff0, dpeff90, dpeff180, dpeff270 : STD_LOGIC;
	signal bdps0, bdps90, bdps180, bdps270, bdpe0, bdpe90, bdpe180, bdpe270 : STD_LOGIC;

begin
u1: DCM_PS generic map(CLKFX_DIVIDE => 1, CLKFX_MULTIPLY => 5)
--u1: DCM_SP generic map(CLKFX_DIVIDE => 1, CLKFX_MULTIPLY => 5)	--for Spartan6
 port map(clkin=>iclk50MHz, clkfb=>clkb, clk0=>clk0, rst=>'0',	CLKFX=>clk250mhz);
u2: bufg port map(I=>clk0, O=>clkb);
u4: bufg port map(I=>clk250mhz, O=>clk250mhzb);

u11: DCM_PS port map(clkin=>clk250mhzb, clkfb=>clk250_0b,
--u11: DCM_SP port map(clkin=>clk250mhzb, clkfb=>clk250_0b,	--for Spartan6
	clk0=>clk250_0, clk90=>clk250_90, clk180=>clk250_180, clk270=>clk250_270, rst=>'0');
u12: bufg port map(I=>clk250_0, O=>clk250_0b);
u13: bufg port map(I=>clk250_90, O=>clk250_90b);
u14: bufg port map(I=>clk250_180, O=>clk250_180b);
u15: bufg port map(I=>clk250_270, O=>clk250_270b);

u20: FDRE port map(C=>clk250_0b, CE=>'1', R=>'0', D=>pstart, Q=>bdps0);
u21: FDRE port map(C=>clk250_90b, CE=>'1', R=>'0', D=>pstart, Q=>bdps90);
u22: FDRE port map(C=>clk250_180b, CE=>'1', R=>'0', D=>pstart, Q=>bdps180);
u23: FDRE port map(C=>clk250_270b, CE=>'1', R=>'0', D=>pstart, Q=>bdps270);
u24: FDRE port map(C=>clk250_0b, CE=>'1', R=>'0', D=>pend, Q=>bdpe0);
u25: FDRE port map(C=>clk250_90b, CE=>'1', R=>'0', D=>pend, Q=>bdpe90);
u26: FDRE port map(C=>clk250_180b, CE=>'1', R=>'0', D=>pend, Q=>bdpe180);
u27: FDRE port map(C=>clk250_270b, CE=>'1', R=>'0', D=>pend, Q=>bdpe270);

pget <= ppget;

process (clkb) 
begin
if clkb='1' and clkb'event then
	dstart<=dps0;	ddstart<=dstart;	dddstart<=ddstart;
	if ddstart='1' and dddstart='0' then
		perr <= '0';
		limit_time <= (others=>'0');
		if dpsf270='0' and dpsf0='1' then
			dpsff0 <= '1';
		elsif dpsf0='0' and dpsf90='1' then
			dpsff90 <= '1';
		elsif dpsf90='0' and dpsf180='1' then
			dpsff180 <= '1';
		elsif dpsf180='0' and dpsf270='1' then
			dpsff270 <= '1';
		end if;
	else
		if limit_time(6)='0' then
			limit_time <= limit_time+1;
		end if;
	end if;
	dend<=dpe0;		d2end<=dend;		d3end<=d2end;		d4end<=d3end;	d5end<=d4end;	d6end<=d5end;
	if d2end='1' and d3end='0' then
		if dpef270='0' and dpef0='1' then
			dpeff0 <= '1';
		elsif dpef0='0' and dpef90='1' then
			dpeff90 <= '1';
		elsif dpef90='0' and dpef180='1' then
			dpeff180 <= '1';
		elsif dpef180='0' and dpef270='1' then
			dpeff270 <= '1';
		end if;
	elsif d3end='1' and d4end='0' then
		if (dpsff0='1' or dpsff90='1' or dpsff180='1' or dpsff270='1') and
				(dpeff0='1' or dpeff90='1' or dpeff180='1' or dpeff270='1') then
			ppend <= '1';
			if dpeff0='1' then
				if dpsff90='1' then	end_time <= dpect0 & "11";
				elsif dpsff180='1' then	end_time <= dpect0 & "10";
				elsif dpsff270='1' then	end_time <= dpect0 & "01";
				else	end_time <= dpect0 & "00";
				end if;
			elsif dpeff90='1' then
				if dpsff180='1' then	end_time <= dpect90 & "11";
				elsif dpsff270='1' then	end_time <= dpect90 & "10";
				elsif dpsff0='1' then	end_time <= dpect90 & "01";
				else	end_time <= dpect90 & "00";
				end if;
			elsif dpeff180='1' then
				if dpsff270='1' then	end_time <= dpect180 & "11";
				elsif dpsff0='1' then	end_time <= dpect180 & "10";
				elsif dpsff90='1' then	end_time <= dpect180 & "01";
				else	end_time <= dpect180 & "00";
				end if;
			else
				if dpsff0='1' then		end_time <= dpect270 & "11";
				elsif dpsff90='1' then	end_time <= dpect270 & "10";
				elsif dpsff180='1' then	end_time <= dpect270 & "01";
				else	end_time <= dpect270 & "00";
				end if;
			end if;
		else
			perr <= '1';
		end if;
	elsif d4end='1' and d5end='0' then
		if ppend='1' and limit_time(6)='0' then
			ppget <= '1';
			pdata <= end_time;	-- - start_time;
--			pdata <= test_ct;	--for test
--			test_ct <= test_ct+1;
		else
			perr <= '1';
		end if;
	else
		ppget <= '0';	ppend <= '0';
		dpeff0 <= '0';	dpeff90 <= '0';	dpeff180 <= '0';	dpeff270 <= '0';
		if ddstart='0' then
			dpsff0 <= '0';	dpsff90 <= '0';	dpsff180 <= '0';	dpsff270 <= '0';
		end if;
	end if;
end if;
end process;

process (clk250_0b) 
begin
if clk250_0b='1' and clk250_0b'event then
	if d6end='0' then
		if bdps0='1' or dps0='1' then
			dps0 <= '1';
			if dps0='0' then
				stamp0 <= (others=>'0');
				if dpsf90='0' and dpsf180='0' and dpsf270='0' then
					dpsf0 <= '1';
				end if;
			else
				stamp0 <= stamp0+1;
			end if;
		end if;
		if bdpe0='1' then
			dpe0 <= '1';
			if dpe0='0' then
				dpect0 <= stamp0;
				if dpef90='0' and dpef180='0' and dpef270='0' then
					dpef0 <= '1';
				end if;
			end if;
		end if;
	else
		dps0 <= '0';
		dpsf0 <= '0';
		dpe0 <= '0';
		dpef0 <= '0';
	end if;
end if;
end process;

process (clk250_90b) 
begin
if clk250_90b='1' and clk250_90b'event then
	if d6end='0' then
		if bdps90='1' or dps90='1' then
			dps90 <= '1';
			if dps90='0' then
				stamp90 <= (others=>'0');
				if dpsf0='0' and dpsf180='0' and dpsf270='0' then
					dpsf90 <= '1';
				end if;
			else
				stamp90 <= stamp90+1;
			end if;
		end if;
		if bdpe90='1' then
			dpe90 <= '1';
			if dpe90='0' then
				dpect90 <= stamp90;
				if dpef0='0' and dpef180='0' and dpef270='0' then
					dpef90 <= '1';
				end if;
			end if;
		end if;
	else
		dps90 <= '0';
		dpsf90 <= '0';
		dpe90 <= '0';
		dpef90 <= '0';
	end if;
end if;
end process;

process (clk250_180b) 
begin
if clk250_180b='1' and clk250_180b'event then
	if d6end='0' then
		if bdps180='1' or dps180='1' then
			dps180 <= '1';
			if dps180='0' then
				stamp180 <= (others=>'0');
				if dpsf90='0' and dpsf0='0' and dpsf270='0' then
					dpsf180 <= '1';
				end if;
			else
				stamp180 <= stamp180+1;
			end if;
		end if;
		if bdpe180='1' then
			dpe180 <= '1';
			if dpe180='0' then
				dpect180 <= stamp180;
				if dpef90='0' and dpef0='0' and dpef270='0' then
					dpef180 <= '1';
				end if;
			end if;
		end if;
	else
		dps180 <= '0';
		dpsf180 <= '0';
		dpe180 <= '0';
		dpef180 <= '0';
	end if;
end if;
end process;

process (clk250_270b) 
begin
if clk250_270b='1' and clk250_270b'event then
	if d6end='0' then
		if bdps270='1' or dps270='1' then
			dps270 <= '1';
			if dps270='0' then
				stamp270 <= (others=>'0');
				if dpsf90='0' and dpsf180='0' and dpsf0='0' then
					dpsf270 <= '1';
				end if;
			else
				stamp270 <= stamp270+1;
			end if;
		end if;
		if bdpe270='1' then
			dpe270 <= '1';
			if dpe270='0' then
				dpect270 <= stamp270;
				if dpef90='0' and dpef180='0' and dpef0='0' then
					dpef270 <= '1';
				end if;
			end if;
		end if;
	else
		dps270 <= '0';
		dpsf270 <= '0';
		dpe270 <= '0';
		dpef270 <= '0';
	end if;
end if;
end process;

end Behavioral;
