----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    07:52:11 05/13/2010 
-- Design Name: 
-- Module Name:    test_WSiT - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity test_WSiT is
    Port ( clkp : in  STD_LOGIC;
	MACCLK : out  STD_LOGIC;	--25MHz
	SW_RST : in  STD_LOGIC;
	mad : inout std_logic_vector(7 downto 0);
		--module address MADD7,..,VADD0
--	#### to MHPD_GS_sub
	PSTART : in  STD_LOGIC;
	PEND : in  STD_LOGIC;
	PTRIGGER : inout  STD_LOGIC;

--	// EEPROM
	EEPROM_CS :		out STD_LOGIC;--	,	// out	: Chip select
	EEPROM_SK :		out STD_LOGIC;--	,	// out	: Serial data clock
	EEPROM_DI :		out STD_LOGIC;--	,	// out	: Serial write data
	EEPROM_DO :		inout STD_LOGIC;--	,	// in	: Serial read data
--	// MII interface
--	GMII_1000M :		in STD_LOGIC;--// in	: GMII mode (0:MII, 1:GMII)
	GMII_RSTn :		out STD_LOGIC;--// in type miss	: PHY reset
	LED_1000Mn :		in STD_LOGIC;--// in	: 1000M mode
--		// TX
	GMII_GTXCLK :		out STD_LOGIC;--// out	: GTx clock(125MHz)
	GMII_TX_CLK :		in STD_LOGIC;--// in	: Tx clock(2.5 or 25MHz)
	GMII_TX_EN :		out STD_LOGIC;--// out	: Tx enable
	GMII_TXD :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Tx data[7:0]
	GMII_TX_ER :		out STD_LOGIC;--// out	: TX error
--		// RX
	GMII_RX_CLK :		in STD_LOGIC;--// in	: Rx clock(2.5 or 25MHz)
	GMII_RX_DV :		in STD_LOGIC;--// in	: Rx data valid
	GMII_RXD :		in STD_LOGIC_VECTOR(7 downto 0);--// in	: Rx data[7:0]
	GMII_RX_ER :		in STD_LOGIC;--// in	: Rx error
	GMII_CRS :		in STD_LOGIC;--// in	: Carrier sense
	GMII_COL :		in STD_LOGIC;--// in	: Collision detected
--		// Management IF
	GMII_MDC :		out STD_LOGIC;--// out	: Clock for MDIO
	GMII_MDIO :		inout STD_LOGIC;--// in	: Data

	led : out  STD_LOGIC_VECTOR(2 downto 0));
end test_WSiT;

architecture Behavioral of test_WSiT is
component WRAP_SiTCP_GMII_XC4_32K
Port (
	CLK :		in STD_LOGIC;--// in	: System clock
	RST :		in STD_LOGIC;--// in	: System reset
--	// Configuration parameters
	FORCE_DEFAULTn :	in STD_LOGIC;--// in	: Load default values
	EXT_IP_ADDR :	in STD_LOGIC_VECTOR(31 downto 0);--// in	: My IP address[31:0]
	EXT_TCP_PORT :	in STD_LOGIC_VECTOR(15 downto 0);--// in	: My TCP main-port #[15:0]
	EXT_RBCP_PORT :	in STD_LOGIC_VECTOR(15 downto 0);--// in	: My UDP RBCP-port #[15:0]
	PHY_ADDR :		in STD_LOGIC_VECTOR(4 downto 0);--// in	: PHY-device MIF address[4:0]
--	// EEPROM
	EEPROM_CS :		out STD_LOGIC;--	,	// out	: Chip select
	EEPROM_SK :		out STD_LOGIC;--	,	// out	: Serial data clock
	EEPROM_DI :		out STD_LOGIC;--	,	// out	: Serial write data
	EEPROM_DO :		in STD_LOGIC;--	,	// in	: Serial read data
--		// user data, intialial values are stored in the EEPROM, 0xFFFF_FC3C-3F
	USR_REG_X3C :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Stored at 0xFFFF_FF3C
	USR_REG_X3D :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Stored at 0xFFFF_FF3D
	USR_REG_X3E :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Stored at 0xFFFF_FF3E
	USR_REG_X3F :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Stored at 0xFFFF_FF3F
--	// MII interface
	GMII_RSTn :		out STD_LOGIC;--// in	: PHY reset
	GMII_1000M :		in STD_LOGIC;--// in	: GMII mode (0:MII, 1:GMII)
--		// TX
	GMII_TX_CLK :		in STD_LOGIC;--// in	: Tx clock(2.5 or 25MHz)
	GMII_TX_EN :		out STD_LOGIC;--// out	: Tx enable
	GMII_TXD :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Tx data[7:0]
	GMII_TX_ER :		out STD_LOGIC;--// out	: TX error
--		// RX
	GMII_RX_CLK :		in STD_LOGIC;--// in	: Rx clock(2.5 or 25MHz)
	GMII_RX_DV :		in STD_LOGIC;--// in	: Rx data valid
	GMII_RXD :		in STD_LOGIC_VECTOR(7 downto 0);--// in	: Rx data[7:0]
	GMII_RX_ER :		in STD_LOGIC;--// in	: Rx error
	GMII_CRS :		in STD_LOGIC;--// in	: Carrier sense
	GMII_COL :		in STD_LOGIC;--// in	: Collision detected
--		// Management IF
	GMII_MDC :		out STD_LOGIC;--// out	: Clock for MDIO
	GMII_MDIO_IN :		in STD_LOGIC;--// in	: Data
	GMII_MDIO_OUT :		out STD_LOGIC;--// out	: Data
	GMII_MDIO_OE :		out STD_LOGIC;--// out	: MDIO output enable
--	// User I/F
	SiTCP_RST :		out STD_LOGIC;--// out	: Reset for SiTCP and related circuits
--		// TCP connection control
	TCP_OPEN_REQ :		in STD_LOGIC;--// in	: Request to connect connection
	TCP_OPEN_ACK :		out STD_LOGIC;--// out	: Acknowledge for open (=Socket busy)
	TCP_ERROR :		out STD_LOGIC;--// out	: TCP error, its active period is equal to MSL
	TCP_CLOSE_REQ :		out STD_LOGIC;--// out	: Connection close
	TCP_CLOSE_ACK :		in STD_LOGIC;--// in	: Acknowledge for close
--		// FIFO I/F
	TCP_RX_WC :		in STD_LOGIC_VECTOR(15 downto 0);--// in	: Fill level[15:0]
	TCP_RX_WR :			out STD_LOGIC;--// out	: Write enable
	TCP_RX_DATA :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Write data[7:0]
	TCP_TX_FULL :		out STD_LOGIC;--// out	: Almost full flag
	TCP_TX_WR :			in STD_LOGIC;--// in	: Write enable
	TCP_TX_DATA :		in STD_LOGIC_VECTOR(7 downto 0);--// in	: Write data[7:0]
--		// RBCP
	RBCP_ACT :		out STD_LOGIC;--// out	: RBCP active
	RBCP_ADDR :		out STD_LOGIC_VECTOR(31 downto 0);--// out	: Address[31:0]
	RBCP_WD :			out STD_LOGIC_VECTOR(7 downto 0);--// out	: Data[7:0]
	RBCP_WE :			out STD_LOGIC;--// out	: Write enable
	RBCP_RE :			out STD_LOGIC;--// out	: Read enable
	RBCP_ACK :		in STD_LOGIC;--// in	: Access acknowledge
	RBCP_RD :			in STD_LOGIC_VECTOR(7 downto 0)--// in	: Read data[7:0]
);
end component;
component EROM128b
    Port ( clk : in std_logic;
           rstn, tcp_establish : in  STD_LOGIC;
           loc_addr : in  STD_LOGIC_VECTOR (31 downto 0);
           loc_we : in  STD_LOGIC;
           loc_wd : in  STD_LOGIC_VECTOR (7 downto 0);
           loc_re : in  STD_LOGIC;
           loc_ack : out  STD_LOGIC;
           loc_rd : out  STD_LOGIC_VECTOR (7 downto 0);

	genkp, genclk, nkp2, clkp2 : in std_logic;
	kpout, kpout2 : out std_logic;
	UDPSEL : out std_logic; 
	UDPWE : out std_logic; 
	UDPREAD : out std_logic; 
 	UDPADD  : out std_logic_vector(7 downto 0); 
 	UDPWDT  : out std_logic_vector(15 downto 0); 
 	UDPRDT  : in std_logic_vector(15 downto 0); 

	rw : in std_logic;
	begf : in std_logic;
	endf, rce : out std_logic;
	add : out std_logic_vector(5 downto 0);
	di : in std_logic_vector(15 downto 0);
	do : out std_logic_vector(15 downto 0);
	derr : out std_logic;

	tmce : out std_logic;
	tmadd : out std_logic_vector(2 downto 0);
	tmdi : out std_logic_vector(15 downto 0);
	tmdo : in std_logic_vector(15 downto 0);

	daadd : in STD_LOGIC_VECTOR(2 downto 0);
	emdt : out STD_LOGIC_VECTOR(63 downto 0);

	tdc_clock : out STD_LOGIC_VECTOR(55 downto 0);	--for TDC timestamp, 2012 2/10

	ptlldtm : out std_logic_vector(63 downto 0);	--lld=(59:48), time_hi=(47:24), time_low(23:0)

	ii_read : out std_logic;
	ii_di : in std_logic_vector(255 downto 0);
	ii_do : out std_logic_vector(255 downto 0);

--	mb : inout std_logic_vector(3 downto 0)); --mb(3)=cs, mb(2)=sk, mb(1)=di, mb(0)=do
	mcs, msk, mdo : out std_logic;
	mdi : in std_logic);
end component;
component test_gclk
Port ( clk : in std_logic;
	kp_o : out std_logic);
end component;

component fifo16_64
 port (clk : in std_logic; 
 	up  : in std_logic; 
 	dw  : in std_logic; 
 	ne  : out std_logic; 
 	nf  : out std_logic; 
 	reset  : in std_logic; 
 	di  : in std_logic_vector(63 downto 0); 
 	do  : out std_logic_vector(63 downto 0)); 
end component;
component TDC_get
    Port ( iclk50MHz : in  STD_LOGIC;	--50MHz
           pstart, pend : in  STD_LOGIC;		--inputs from TDC
           pget : out  STD_LOGIC;		--get TDC data
           perr : out  STD_LOGIC;		--error
           pdata : out  STD_LOGIC_VECTOR (8 downto 0));	--output time data
end component;

	signal iclk, clk0, clkb, locked, ptcp_establish, tcp_cls_req, tcp_cls_ack : STD_LOGIC;
	signal mdio_in, mdio_out, mdio_oe, c25mhz, clk2p5x, clk2p5xb, reset : STD_LOGIC;
	signal G1000M, int_GMII_TX_CLK, clk0_2, clkb_2, clk3x, clkb_net, locked_2 : STD_LOGIC;
	signal lledct : STD_LOGIC_VECTOR(25 downto 0);

	signal tx_wd : STD_LOGIC_VECTOR(7 downto 0);
	signal tx_we, tx_afull : STD_LOGIC;

--	signal clkfx_4, clkb_40MHz, clk0_4, clkb_4 : STD_LOGIC;
--	signal clkfx_3, clkb_80MHz, clk0_3, clk90_3, clkb_3 : STD_LOGIC;

	signal loc_we, loc_re, loc_ack, ii_read, genkp, genclk, kpout, led2b, loc_act : STD_LOGIC;
	signal loc_addr : STD_LOGIC_VECTOR(31 downto 0);
	signal loc_wd, loc_rd : STD_LOGIC_VECTOR(7 downto 0);
	signal tmce_er, tmce_tc, tmclr, sreset, dsr, ddsr : STD_LOGIC;
	signal tmadd, tmadd_er, tmadd_tc : STD_LOGIC_VECTOR(2 downto 0);
	signal tmdi, tmdi_er, tmdi_tc, tmdo, sel_tes : STD_LOGIC_VECTOR(15 downto 0);
	signal ii_di, ii_do : STD_LOGIC_VECTOR(255 downto 0);
	signal ptlldtm : STD_LOGIC_VECTOR(63 downto 0);
		--ptlldtm(59:48), ptlldtm(47:24), ptlldtm(23:0)
	signal udpsel, pudpsel, udpwe, udpread, daset, ddaset, dadt : STD_LOGIC;
	signal rframe, tsout, ts0, ts1, ts0a, ts1a, dadin, dtcp_est, evrce : STD_LOGIC;
	signal udpadd : STD_LOGIC_VECTOR(7 downto 0);
	signal udpwdt, udprdt, tdw, ptdw : STD_LOGIC_VECTOR(15 downto 0);

	signal my_ip_add_real : STD_LOGIC_VECTOR(31 downto 0);

	signal ppget, pperr, ev_flag, dptrig, ddptrig, eup, edown, write_flag, neq : STD_LOGIC;
	signal tdc_clock : STD_LOGIC_VECTOR(55 downto 0);	--2012 2/10
	signal tdc_evdata, tdc_evdi : STD_LOGIC_VECTOR(63 downto 0);	--2012 2/10
	signal tdc_evct : STD_LOGIC_VECTOR(3 downto 0);	--2012 2/10
	signal pdata : STD_LOGIC_VECTOR(8 downto 0);	--2012 2/10

	constant my_tcp_port: STD_LOGIC_VECTOR(15 downto 0) := X"0018";	--24
	constant my_ip_addr: STD_LOGIC_VECTOR(31 downto 0) := X"c0a80010";	--192.168.0.16
	constant my_udp_port: STD_LOGIC_VECTOR(15 downto 0) := X"1234";

begin
u40: TDC_get port map(clkb, pstart, pend, ppget, pperr, pdata);

U120: EROM128b port map(clkb, reset, ptcp_establish, loc_addr, loc_we, loc_wd, loc_re, loc_ack, loc_rd,
	genkp, genclk, '0', '0', kpout, open, pudpsel, udpwe, udpread, udpadd, udpwdt, udprdt,
	'0', '0', open, open, open, X"0000", open, open,	tmce_er, tmadd_er, tmdi_er, tmdo,	"000", open,	--2008 9/16
	tdc_clock, ptlldtm,	ii_read, ii_di, ii_do,	 open, open, open, '0');	--adding tdc_clock on 2012 2/10
udpsel <= pudpsel and loc_act;
U121: test_gclk port map(clkb, genclk);

u0: ibufg port map(I=>clkp, O=>iclk);
u1: DCM_PS generic map(CLKDV_DIVIDE =>2.0, CLKFX_DIVIDE =>2, CLKFX_MULTIPLY => 5)
 port map(clkin=>iclk, clkfb=>clkb, clk0=>clk0, LOCKED=>locked, rst=>'0',	CLKDV=>c25mhz, CLKFX=>clk2p5x);
u2: bufg port map(I=>clk0, O=>clkb);
u4: bufg port map(I=>clk2p5x, O=>clk2p5xb);
u5 : BUFGMUX port map (
      O => int_GMII_TX_CLK,    -- Clock MUX output
      I0 => GMII_TX_CLK,  -- Clock0 input
      I1 => CLK2p5x,  -- Clock1 input, 125MHz
      S => G1000M     -- Clock select input
   );
G1000M <= not LED_1000Mn;
GMII_MDIO <= mdio_out when mdio_oe='1' else 'Z';
mdio_in <= GMII_MDIO;

led(0) <= ptcp_establish or lledct(25) when ptcp_establish='0' else lledct(22);
led(1) <= not LED_1000Mn or lledct(25);
led(2) <= pperr;
puerom: pullup port map(O=>EEPROM_DO);
MACCLK <= c25mhz;
GMII_GTXCLK <= CLK2p5x;	--125MHz @50MHz
reset <= not SW_RST or not locked;

--IP address=192.168.0.16, port=24
u30: WRAP_SiTCP_GMII_XC4_32K port map(clkb, reset, '1', my_ip_add_real, my_tcp_port, my_udp_port, "00111",
	EEPROM_CS, EEPROM_SK, EEPROM_DI, EEPROM_DO, open, open, open, open,
	GMII_RSTn, G1000M, int_GMII_TX_CLK, GMII_TX_EN, GMII_TXD, GMII_TX_ER, GMII_RX_CLK, GMII_RX_DV,
	GMII_RXD, GMII_RX_ER, GMII_CRS, GMII_COL, GMII_MDC, MDIO_IN, MDIO_OUT, MDIO_OE,
	open, '0', ptcp_establish, led2b, tcp_cls_req, tcp_cls_ack,
	X"0000", open, open, tx_afull, tx_we, tx_wd,
	loc_act, loc_addr, loc_wd, loc_we, loc_re, loc_ack, loc_rd);
my_ip_add_real(31 downto 8) <= my_ip_addr(31 downto 8);
my_ip_add_real(7 downto 0) <= my_ip_addr(7 downto 0) + mad;

GEN2:	for i in 0 to 7 generate
pum: pullup port map(O=>mad(i));
end generate;

u12: fifo16_64 port map(clkb, eup, edown, neq, open, not ptcp_establish, tdc_evdi, tdc_evdata);
pdw0: pulldown port map(O=>ptrigger);

process (CLKb) 
begin
if CLKb='1' and CLKb'event then
	lledct <= lledct+1;
	dptrig <= ptrigger;
	ddptrig <= dptrig;
	if ptcp_establish='1' then
		if dptrig='1' and ddptrig='0' then
			eup <= '1';
			tdc_evdi <= X"58"&tdc_clock;
		elsif ppget='1' then
			eup <= '1';
			tdc_evdi <= X"59"&tdc_clock(55 downto 9)&pdata;
		else
			eup <= '0';
		end if;
		if neq='1' and edown <= '0' and write_flag='0' then
			write_flag <= '1';
			tx_we <= '0';
			tdc_evct <= (others=>'0');
		elsif write_flag='1' and tx_afull='0' then
			tdc_evct <= tdc_evct+1;
			tx_we <= '1';
			if tdc_evct="000" then
				tx_wd <= tdc_evdata(63 downto 56);
			elsif tdc_evct="001" then
				tx_wd <= tdc_evdata(55 downto 48);
			elsif tdc_evct="010" then
				tx_wd <= tdc_evdata(47 downto 40);
			elsif tdc_evct="011" then
				tx_wd <= tdc_evdata(39 downto 32);
			elsif tdc_evct="100" then
				tx_wd <= tdc_evdata(31 downto 24);
			elsif tdc_evct="101" then
				tx_wd <= tdc_evdata(23 downto 16);
			elsif tdc_evct="110" then
				tx_wd <= tdc_evdata(15 downto 8);
			else
				tx_wd <= tdc_evdata(7 downto 0);
				edown <= '1';
				write_flag <= '0';
			end if;
		else
			tx_we <= '0';
		end if;
	else
		ev_flag <= '0';
		write_flag <= '0';
		tx_we <= '0';
	end if;
	tcp_cls_ack <= tcp_cls_req;
	if edown='1' then
		edown <= '0';
	end if;
end if;
end process;

end Behavioral;

